From: Ole Streicher <olebole@debian.org>
Date: Sat, 1 Dec 2018 14:34:56 +0100
Subject: Trap errors in Makefile

Closes: #915163
---
 Makefile             |  24 +++----
 MontageLib/Makefile  | 172 +++++++++++++++++++++++++--------------------------
 grid/Makefile        |  12 ++--
 lib/src/Makefile     |  46 +++++++-------
 util/Makefile        |  44 ++++++-------
 web/mTAP/Makefile    |   4 +-
 web/mViewer/Makefile |   2 +-
 7 files changed, 153 insertions(+), 151 deletions(-)

diff --git a/Makefile b/Makefile
index de040ed..2bc6eb9 100644
--- a/Makefile
+++ b/Makefile
@@ -4,20 +4,20 @@ CPPFLAGS += -I/usr/include/wcstools -I/usr/include/freetype2
 all:
 	mkdir -p bin
 	mkdir -p lib/include
-	if test -d lib/src;    then (cd lib/src;    make); fi
-	if test -d Montage;    then (cd Montage;  ./Configure.sh; make; make install); fi
-	if test -d util;       then (cd util;       make); fi
-	if test -d grid;       then (cd grid;       make); fi
-	if test -d MontageLib; then (cd MontageLib; make); fi
-	if test -d ancillary;  then (cd ancillary;  make; make install); fi
+	test -d lib/src && (cd lib/src && make)
+	test -d Montage && (cd Montage && ./Configure.sh && make && make install)
+	test -d util && (cd util && make)
+	test -d grid && (cd grid && make)
+	test -d MontageLib && (cd MontageLib && make)
+	test -d ancillary && (cd ancillary && make && make install)
 
 clean:
 	mkdir -p bin
 	mkdir -p lib/include
 	rm -rf bin/*
-	if test -d lib/src;    then (cd lib/src;    make clean); fi || true
-	if test -d Montage;    then (cd Montage;    make clean); fi || true
-	if test -d util;       then (cd util;       make clean); fi || true
-	if test -d grid;       then (cd grid;       make clean); fi || true
-	if test -d MontageLib; then (cd MontageLib; make clean); fi || true
-	if test -d ancillary;  then (cd ancillary;  make clean); fi || true
+	test -d lib/src && (cd lib/src && make clean) || true
+	test -d Montage && (cd Montage && make clean) || true
+	test -d util && (cd util && make clean) || true
+	test -d grid && (cd grid && make clean) || true
+	test -d MontageLib && (cd MontageLib && make clean) || true
+	test -d ancillary && (cd ancillary && make clean) || true
diff --git a/MontageLib/Makefile b/MontageLib/Makefile
index 809d4b4..a1c3631 100644
--- a/MontageLib/Makefile
+++ b/MontageLib/Makefile
@@ -9,49 +9,49 @@ endif
 all: pgm lib pythonlibs
 
 pgm: 
-		(cd util;                          make)
-		-(cd Add;           ./Configure.sh; make; make install)
-		-(cd AddCube;       ./Configure.sh; make; make install)
-		-(cd ArchiveList;   ./Configure.sh; make; make install)
-		-(cd ArchiveGet;                    make; make install)
-		-(cd ArchiveExec;                   make; make install)
-		-(cd Background;    ./Configure.sh; make; make install)
-		-(cd BestImage;                     make; make install)
-		-(cd BgModel;                       make; make install)
-		-(cd CoverageCheck; ./Configure.sh; make; make install)
-		-(cd Diff;          ./Configure.sh; make; make install)
-		-(cd Examine;       ./Configure.sh; make; make install)
-		-(cd Fitplane;                      make; make install)
-		-(cd FixNaN;        ./Configure.sh; make; make install)
-		-(cd GetHdr;                        make; make install)
-		-(cd Hdr;           ./Configure.sh; make; make install)
-		-(cd Histogram;                     make; make install)
-		-(cd Imgtbl;        ./Configure.sh; make; make install)
-		-(cd MakeHdr;       ./Configure.sh; make; make install)
-		-(cd MakeImg;       ./Configure.sh; make; make install)
-		-(cd Overlaps;      ./Configure.sh; make; make install)
-		-(cd Project;       ./Configure.sh; make; make install)
-		-(cd ProjectCube;   ./Configure.sh; make; make install)
-		-(cd ProjectPP;     ./Configure.sh; make; make install)
-		-(cd ProjectQL;     ./Configure.sh; make; make install)
-		-(cd PutHdr;                        make; make install)
-		-(cd ShrinkCube;                    make; make install)
-		-(cd Shrink;                        make; make install)
-		-(cd SubCube;       ./Configure.sh; make; make install)
-		-(cd Subimage;      ./Configure.sh; make; make install)
-		-(cd TANHdr;                        make; make install)
-		-(cd Transpose;     ./Configure.sh; make; make install)
-		-(cd WWT;           ./Configure.sh; make; make install)
-		-(cd Viewer;        ./Configure.sh; make; make install)
-		-(cd DiffExec;                      make; make install)
-		-(cd BgExec;                        make; make install)
-		-(cd DiffFitExec;                   make; make install)
-		-(cd FitExec;                       make; make install)
-		-(cd ProjExec;      ./Configure.sh; make; make install)
+		(cd util &&                          make)
+		(cd Add &&         ./Configure.sh && make && make install)
+		(cd AddCube &&     ./Configure.sh && make && make install)
+		(cd ArchiveList && ./Configure.sh && make && make install)
+		(cd ArchiveGet &&                    make && make install)
+		(cd ArchiveExec &&                   make && make install)
+		(cd Background &&  ./Configure.sh && make && make install)
+		(cd BestImage &&                     make && make install)
+		(cd BgModel &&                       make && make install)
+		(cd CoverageCheck && ./Configure.sh && make && make install)
+		(cd Diff &&        ./Configure.sh && make && make install)
+		(cd Examine &&     ./Configure.sh && make && make install)
+		(cd Fitplane &&                      make && make install)
+		(cd FixNaN &&      ./Configure.sh && make && make install)
+		(cd GetHdr &&                        make && make install)
+		(cd Hdr &&         ./Configure.sh && make && make install)
+		(cd Histogram &&                     make && make install)
+		(cd Imgtbl &&      ./Configure.sh && make && make install)
+		(cd MakeHdr &&     ./Configure.sh && make && make install)
+		(cd MakeImg &&     ./Configure.sh && make && make install)
+		(cd Overlaps &&    ./Configure.sh && make && make install)
+		(cd Project &&     ./Configure.sh && make && make install)
+		(cd ProjectCube && ./Configure.sh && make && make install)
+		(cd ProjectPP &&   ./Configure.sh && make && make install)
+		(cd ProjectQL &&   ./Configure.sh && make && make install)
+		(cd PutHdr &&                        make && make install)
+		(cd ShrinkCube &&                    make && make install)
+		(cd Shrink &&                        make && make install)
+		(cd SubCube &&     ./Configure.sh && make && make install)
+		(cd Subimage &&    ./Configure.sh && make && make install)
+		(cd TANHdr &&                        make && make install)
+		(cd Transpose &&   ./Configure.sh && make && make install)
+		(cd WWT &&         ./Configure.sh && make && make install)
+		(cd Viewer &&      ./Configure.sh && make && make install)
+		(cd DiffExec &&                      make && make install)
+		(cd BgExec &&                        make && make install)
+		(cd DiffFitExec &&                   make && make install)
+		(cd FitExec &&                       make && make install)
+		(cd ProjExec &&    ./Configure.sh && make && make install)
 
 lib:
-		-rm -f libmontage.a libmontage.so libmontagepy.so
-		-ar q  libmontage.a \
+		rm -f libmontage.a libmontage.so libmontagepy.so
+		ar q  libmontage.a \
 			util/checkFile.o util/checkHdr.o util/checkWCS.o \
 			util/debugCheck.o util/filePath.o \
 			Add/montageAdd.o \
@@ -93,7 +93,7 @@ lib:
 			FitExec/montageFitExec.o \
 			DiffFitExec/montageDiffFitExec.o \
 			ProjExec/montageProjExec.o 
-		-$(CC) -shared $(SO_FLAG) -o libmontage.so \
+		$(CC) -shared $(SO_FLAG) -o libmontage.so \
 			util/checkFile.o util/checkHdr.o util/checkWCS.o \
 			util/debugCheck.o util/filePath.o \
 			Add/montageAdd.o \
@@ -137,8 +137,8 @@ lib:
 			ProjExec/montageProjExec.o 
 
 pythonlibs:
-		-rm -f ../python/MontagePy/lib/*.o
-		-cp util/checkFile.o util/checkHdr.o util/checkWCS.o \
+		rm -f ../python/MontagePy/lib/*.o
+		cp util/checkFile.o util/checkHdr.o util/checkWCS.o \
 			util/debugCheck.o util/filePath.o \
 			Add/montageAdd.o \
 			AddCube/montageAddCube.o \
@@ -203,7 +203,7 @@ pythonlibs:
 			../lib/src/two_plane_v1.1/undistort.o \
 			../lib/src/www/www.o \
          ../python/MontagePy/lib
-		-cp ../lib/src/two_plane_v1.1/distort.o       ../python/MontagePy/lib/two_plane_distort.o
+		cp ../lib/src/two_plane_v1.1/distort.o       ../python/MontagePy/lib/two_plane_distort.o
 # The last four lines are needed because we have .o file name conflicts
 
 doc:
@@ -287,44 +287,44 @@ jupyter:
 			mJupyter ProjExec
 
 clean:
-		-(cd util;          make clean)
-		-(cd Add;           make clean)
-		-(cd AddCube;       make clean)
-		-(cd ArchiveList;   make clean)
-		-(cd ArchiveGet;    make clean)
-		-(cd ArchiveExec;   make clean)
-		-(cd Background;    make clean)
-		-(cd BestImage;     make clean)
-		-(cd BgModel;       make clean)
-		-(cd CoverageCheck; make clean)
-		-(cd Diff;          make clean)
-		-(cd Examine;       make clean)
-		-(cd Fitplane;      make clean)
-		-(cd FixNaN;        make clean)
-		-(cd GetHdr;        make clean)
-		-(cd Hdr;           make clean)
-		-(cd Histogram;     make clean)
-		-(cd Imgtbl;        make clean)
-		-(cd MakeHdr;       make clean)
-		-(cd MakeImg;       make clean)
-		-(cd Overlaps;      make clean)
-		-(cd ProjectCube;   make clean)
-		-(cd Project;       make clean)
-		-(cd ProjectPP;     make clean)
-		-(cd ProjectQL;     make clean)
-		-(cd PutHdr;        make clean)
-		-(cd ShrinkCube;    make clean)
-		-(cd Shrink;        make clean)
-		-(cd SubCube;       make clean)
-		-(cd Subimage;      make clean)
-		-(cd TANHdr;        make clean)
-		-(cd Transpose;     make clean)
-		-(cd WWT;           make clean)
-		-(cd Viewer;        make clean)
-		-(cd DiffExec;      make clean)
-		-(cd BgExec;        make clean)
-		-(cd DiffFitExec;   make clean)
-		-(cd FitExec;       make clean)
-		-(cd ProjExec;      make clean)
-		-rm -f libmontage.a libmontage.so
-		-rm -f ../python/MontagePy/lib/*.o
+		(cd util &&        make clean)
+		(cd Add &&         make clean)
+		(cd AddCube &&     make clean)
+		(cd ArchiveList && make clean)
+		(cd ArchiveGet &&  make clean)
+		(cd ArchiveExec && make clean)
+		(cd Background &&  make clean)
+		(cd BestImage &&   make clean)
+		(cd BgModel &&     make clean)
+		(cd CoverageCheck && make clean)
+		(cd Diff &&        make clean)
+		(cd Examine &&     make clean)
+		(cd Fitplane &&    make clean)
+		(cd FixNaN &&      make clean)
+		(cd GetHdr &&      make clean)
+		(cd Hdr &&         make clean)
+		(cd Histogram &&   make clean)
+		(cd Imgtbl &&      make clean)
+		(cd MakeHdr &&     make clean)
+		(cd MakeImg &&     make clean)
+		(cd Overlaps &&    make clean)
+		(cd ProjectCube && make clean)
+		(cd Project &&     make clean)
+		(cd ProjectPP &&   make clean)
+		(cd ProjectQL &&   make clean)
+		(cd PutHdr &&      make clean)
+		(cd ShrinkCube &&  make clean)
+		(cd Shrink &&      make clean)
+		(cd SubCube &&     make clean)
+		(cd Subimage &&    make clean)
+		(cd TANHdr &&      make clean)
+		(cd Transpose &&   make clean)
+		(cd WWT &&         make clean)
+		(cd Viewer &&      make clean)
+		(cd DiffExec &&    make clean)
+		(cd BgExec &&      make clean)
+		(cd DiffFitExec && make clean)
+		(cd FitExec &&     make clean)
+		(cd ProjExec &&    make clean)
+		rm -f libmontage.a libmontage.so
+		rm -f ../python/MontagePy/lib/*.o
diff --git a/grid/Makefile b/grid/Makefile
index 225ffb7..48101d9 100644
--- a/grid/Makefile
+++ b/grid/Makefile
@@ -1,9 +1,9 @@
 all:
-	(cd Pegasus; ./Configure.sh; make; make install)
-	(cd Globus/ExecTG; ./Configure.sh; make; make install)
-	(cd Globus/NotifyTG; ./Configure.sh; make; make install)
+	(cd Pegasus && ./Configure.sh && make && make install)
+	(cd Globus/ExecTG && ./Configure.sh && make && make install)
+	(cd Globus/NotifyTG && ./Configure.sh && make && make install)
 
 clean:
-	(cd Pegasus; make clean)
-	(cd Globus/ExecTG; make clean)
-	(cd Globus/NotifyTG; make clean)
+	(cd Pegasus && make clean)
+	(cd Globus/ExecTG && make clean)
+	(cd Globus/NotifyTG && make clean)
diff --git a/lib/src/Makefile b/lib/src/Makefile
index 4c379cc..c45bc45 100644
--- a/lib/src/Makefile
+++ b/lib/src/Makefile
@@ -1,27 +1,29 @@
+.SHELLFLAGS := -ec
+
 all:
-	(cd cmd; make; make install)
-	(cd coord; make; make install)
-	(cd mtbl; make; make install)
-	(cd svc; make; make install)
-	(cd json; make; make install)
-	(cd boundaries; make; make install)
-	(cd pixbounds; make; make install)
-	(cd www; make; make install)
-	(cd two_plane_v1.1; make; make install)
-	(cd lodepng_20140823; make; make install)
-	(cd ..; ranlib *.a)
+	(cd cmd && make && make install)
+	(cd coord && make && make install)
+	(cd mtbl && make && make install)
+	(cd svc && make && make install)
+	(cd json && make && make install)
+	(cd boundaries && make && make install)
+	(cd pixbounds && make && make install)
+	(cd www && make && make install)
+	(cd two_plane_v1.1 && make && make install)
+	(cd lodepng_20140823 && make && make install)
+	(cd .. && ranlib *.a)
 	chmod 644 ../include/*.h
 
 clean:
 	rm -rf ../include/* ../freetype ../*.a
-	(cd cmd; make clean)
-	(cd coord; make clean)
-	(cd mtbl; make clean)
-	(cd svc; make clean)
-	(cd json; make clean)
-	(cd boundaries; make clean)
-	(cd www; make clean)
-	(cd pixbounds; make clean)
-	(cd www; make clean)
-	(cd two_plane_v1.1; make clean)
-	(cd lodepng_20140823; make clean)
+	(cd cmd && make clean)
+	(cd coord && make clean)
+	(cd mtbl && make clean)
+	(cd svc && make clean)
+	(cd json && make clean)
+	(cd boundaries && make clean)
+	(cd www && make clean)
+	(cd pixbounds && make clean)
+	(cd www && make clean)
+	(cd two_plane_v1.1 && make clean)
+	(cd lodepng_20140823 && make clean)
diff --git a/util/Makefile b/util/Makefile
index ea8d6af..3f67c3c 100644
--- a/util/Makefile
+++ b/util/Makefile
@@ -1,26 +1,26 @@
 all:
-	-(cd Calibrate; make; make install)
-	-(cd CatMap; ./Configure.sh; make; make install)
-	-(cd CatSearch; make; make install)
-	-(cd Exec; ./Configure.sh; make; make install)
-	-(cd MovingTarget; ./Configure.sh; make; make install)
-	-(cd Pad; ./Configure.sh; make; make install)
-	-(cd Pix2Coord; ./Configure.sh; make; make install)
-	-(cd Rotate; ./Configure.sh; make; make install)
-	-(cd Search; ./Configure.sh; make; make install)
-	-(cd ShrinkHdr; ./Configure.sh; make; make install)
-	-(cd TblExec; make; make install)
+	(cd Calibrate && make && make install)
+	(cd CatMap && ./Configure.sh && make && make install)
+	(cd CatSearch && make && make install)
+	(cd Exec && ./Configure.sh && make && make install)
+	(cd MovingTarget && ./Configure.sh && make && make install)
+	(cd Pad && ./Configure.sh && make && make install)
+	(cd Pix2Coord && ./Configure.sh && make && make install)
+	(cd Rotate && ./Configure.sh && make && make install)
+	(cd Search && ./Configure.sh && make && make install)
+	(cd ShrinkHdr && ./Configure.sh && make && make install)
+	(cd TblExec && make && make install)
 
 
 clean:
-	-(cd Calibrate; make clean)
-	-(cd CatMap; make clean)
-	-(cd CatSearch; make clean)
-	-(cd Exec; make clean)
-	-(cd MovingTarget; make clean)
-	-(cd Pad; make clean)
-	-(cd Pix2Coord; make clean)
-	-(cd Rotate; make clean)
-	-(cd Search; make clean)
-	-(cd ShrinkHdr; make clean)
-	-(cd TblExec; make clean)
+	(cd Calibrate && make clean)
+	(cd CatMap && make clean)
+	(cd CatSearch && make clean)
+	(cd Exec && make clean)
+	(cd MovingTarget && make clean)
+	(cd Pad && make clean)
+	(cd Pix2Coord && make clean)
+	(cd Rotate && make clean)
+	(cd Search && make clean)
+	(cd ShrinkHdr && make clean)
+	(cd TblExec && make clean)
diff --git a/web/mTAP/Makefile b/web/mTAP/Makefile
index 96d1123..8ab915e 100644
--- a/web/mTAP/Makefile
+++ b/web/mTAP/Makefile
@@ -143,10 +143,10 @@ install :       $(progs) data.tar webcontent.tar installdirs
 		$(INSTALL_PROGRAM) $(progs) $(cgidir)
 		rm -rf $(datadir)/*
 		$(INSTALL_DATA) data.tar $(datadir)
-		cd $(datadir); tar -xf data.tar; rm data.tar
+		cd $(datadir) && tar xf data.tar && rm data.tar
 		rm -rf $(appdir)/*
 		$(INSTALL_DATA) webcontent.tar $(appdir)
-		cd $(appdir); tar -xf webcontent.tar; rm webcontent.tar
+		cd $(appdir) && tar -xf webcontent.tar && rm webcontent.tar
 
 # Uninstalls the product
 uninstall :
diff --git a/web/mViewer/Makefile b/web/mViewer/Makefile
index c28e4ee..293d5cf 100644
--- a/web/mViewer/Makefile
+++ b/web/mViewer/Makefile
@@ -221,7 +221,7 @@ install :       $(progs) data.tar webcontent.tar installdirs
 #		cd $(datadir); tar -xf data.tar; rm data.tar
 		rm -rf $(appdir)/*
 		$(INSTALL_DATA) webcontent.tar $(appdir)
-		cd $(appdir); tar -xf webcontent.tar; rm webcontent.tar
+		cd $(appdir) && tar xf webcontent.tar && rm webcontent.tar
 		mv $(appdir)/mViewer.js $(appdir)/mViewer_v1.0.js
 
 
